
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef viman_TCLSERV_CLIENT_ERROR_H
#define viman_TCLSERV_CLIENT_ERROR_H

#include <server/vimanError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum viman_error {
	E_viman_OK					  			= 0,

	/* module errors */
	E_viman_CANNOT_FIND_OBJECT             = S_viman_CANNOT_FIND_OBJECT,
	E_viman_SUCCESS                        = S_viman_SUCCESS,
	E_viman_TRACKING_ACTIVATION_FAILED     = S_viman_TRACKING_ACTIVATION_FAILED,
	E_viman_CANNOT_READ_CONFIG_FILE        = S_viman_CANNOT_READ_CONFIG_FILE,
	E_viman_CANNOT_READ_POSTER             = S_viman_CANNOT_READ_POSTER,
	E_viman_POSTER_NOT_FOUND               = S_viman_POSTER_NOT_FOUND,
	E_viman_CANNOT_OPEN_VIDEO_STREAM       = S_viman_CANNOT_OPEN_VIDEO_STREAM,
	E_viman_OPENCV_QUERY_FRAME_PROBLEM     = S_viman_OPENCV_QUERY_FRAME_PROBLEM,
	E_viman_VIDEO_MODE_INCONSISTENCY       = S_viman_VIDEO_MODE_INCONSISTENCY,
	E_viman_NO_VIDEO_MODE_IS_DEFINED       = S_viman_NO_VIDEO_MODE_IS_DEFINED,
	E_viman_VIMAN_UNINITIALIZED            = S_viman_VIMAN_UNINITIALIZED,


	/* std errors */
	E_viman_ACTIVITY_INTERRUPTED           = S_viman_stdGenoM_ACTIVITY_INTERRUPTED,
	E_viman_TOO_MANY_ACTIVITIES            = S_viman_stdGenoM_TOO_MANY_ACTIVITIES,
	E_viman_ACTIVITY_FAILED                = S_viman_stdGenoM_ACTIVITY_FAILED,
	E_viman_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_viman_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_viman_UNKNOWN_ACTIVITY               = S_viman_stdGenoM_UNKNOWN_ACTIVITY,
	E_viman_FORBIDDEN_ACTIVITY_TRANSITION  = S_viman_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_viman_SYSTEM_ERROR                   = S_viman_stdGenoM_SYSTEM_ERROR,
	E_viman_ACTIVITY_ALREADY_ENDED         = S_viman_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_viman_WAIT_INIT_RQST                 = S_viman_stdGenoM_WAIT_INIT_RQST,
	E_viman_CONTROL_CODEL_ERROR            = S_viman_stdGenoM_CONTROL_CODEL_ERROR,
	E_viman_EXEC_TASK_SUSPENDED            = S_viman_stdGenoM_EXEC_TASK_SUSPENDED,
	E_viman_BAD_BLOCK_TYPE                 = S_viman_stdGenoM_BAD_BLOCK_TYPE,
	E_viman_BAD_POSTER_TYPE                = S_viman_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum viman_error viman_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int viman_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the viman context.
 *
 * Returns NULL in case of failure
 */
const char* viman_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
